;;;; t.scm - tests for typed-records.scm


(use typed-records)


(define-typed-record point
  x
  (y : number))

(define-typed-record-type point3
  (make-point3 y x)
  point3?
  (x get-x set-x : number)
  (y get-y : number)
  (foo get-foo)
  (bar get-bar set-bar)
  (baz get-baz : float)
  (goo get-goo set-foo : pointer))

(defstruct-typed person
  name
  (age : fixnum)
  ((species 'human) : symbol)
  (planet 'earth))

(define-syntax assert-type
  (syntax-rules ()
    ((_ t x)
     (compiler-typecase x
       (t 'ok)))))

(let ((pt (make-point 1 2))
      (p3 (make-point3 1 2)))

  (assert-type number (point-y pt))
  (assert-type float (get-baz p3))

  (when (point? pt)
    (assert-type (struct point) pt))

  (assert-type (struct person) (make-person))

  (set! person-age 42)

  (let ((p (make-person age: 33)))
    (compiler-typecase (person-age p)
      (fixnum 'ok))
    (assert (= 33 (person-age p))))

  )
